HanMacWrdKGraph Class Reference documentation

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | Protected Attributes | Private Member Functions | Friends | List of all members
HanMacWrdKGraph Class Reference

the main class to read the graphic part of a HanMac Word file More...

`#include <HanMacWrdKGraph.hxx>`

## Public Member Functions
| HanMacWrdKGraph (HanMacWrdKParser &parser)
| constructor More...
virtual | ~HanMacWrdKGraph ()
| destructor More...
int | version () const
| returns the file version More...
int | numPages () const
| returns the number of pages More...

## Protected Member Functions
bool | getColor (int colId, int patternId, MWAWColor &color) const
| returns the color associated with a pattern More...
bool | sendPageGraphics (std::vector< long > const &doNotSendIds)
| try to send the page graphic More...
void | flushExtra ()
| sends the data which have not yet been sent to the listener More...
bool | readFrames (shared_ptr< HanMacWrdKZone > zone)
| try to read the frame definition (type 2) More...
bool | readPicture (shared_ptr< HanMacWrdKZone > zone)
| try to read a picture zone (type d) More...
void | prepareStructures ()
| check the group structures, the linked textbox More...
bool | sendFrame (long frameId, MWAWPosition pos)
| try to send a frame to the listener More...
bool | sendPicture (long pictId, MWAWPosition pos)
| try to send a picture to the listener More...
bool | sendText (long textId, long id, MWAWListenerPtr listener=MWAWListenerPtr())
| ask main parser to send a text zone More...
std::map< long, int > | getTextFrameInformations () const
| return a list textZId -> type which 3(footnote), 4(textbox), 9(table), 10(comment) More...
bool | checkGroupStructures (long fileId, long fileSubId, std::multimap< long, long > &seens, bool inGroup)
| check the graph structures: ie. More...
bool | sendPicture (HanMacWrdKGraphInternal::Picture const &picture, MWAWPosition pos)
| try to send a picture to the listener More...
bool | sendFrame (HanMacWrdKGraphInternal::Frame const &frame, MWAWPosition pos)
| try to send a frame to the listener More...
bool | sendShapeGraph (HanMacWrdKGraphInternal::ShapeGraph const &shape, MWAWPosition pos)
| try to send a basic picture to the listener More...
bool | sendPictureFrame (HanMacWrdKGraphInternal::PictureFrame const &pict, MWAWPosition pos)
| try to send a picture frame More...
bool | sendEmptyPicture (MWAWPosition pos)
| try to send an empty picture More...
bool | sendTextBox (HanMacWrdKGraphInternal::TextBox const &textbox, MWAWPosition pos)
| try to send a textbox to the listener More...
bool | sendTableUnformatted (long fId)
| try to send a table unformatted More...
bool | sendGroup (long fId, MWAWPosition pos)
| try to send a group to the listener More...
bool | sendGroup (HanMacWrdKGraphInternal::Group const &group, MWAWPosition pos)
| try to send a group to the listener More...
bool | canCreateGraphic (HanMacWrdKGraphInternal::Group const &group)
| check if we can send a group as graphic More...
void | sendGroupChild (HanMacWrdKGraphInternal::Group const &group, MWAWPosition const &pos)
| try to send a group elements by elements More...
void | sendGroup (HanMacWrdKGraphInternal::Group const &group, MWAWGraphicListenerPtr &listener)
| send the group as a graphic zone More...
shared_ptr< HanMacWrdKGraphInternal::ShapeGraph > | readShapeGraph (shared_ptr< HanMacWrdKZone > zone, HanMacWrdKGraphInternal::Frame const &header)
| try to read the basic graph data More...
shared_ptr< HanMacWrdKGraphInternal::FootnoteFrame > | readFootnoteFrame (shared_ptr< HanMacWrdKZone > zone, HanMacWrdKGraphInternal::Frame const &header)
| try to read the footnote data More...
shared_ptr< HanMacWrdKGraphInternal::Group > | readGroup (shared_ptr< HanMacWrdKZone > zone, HanMacWrdKGraphInternal::Frame const &header)
| try to read the group data More...
shared_ptr< HanMacWrdKGraphInternal::PictureFrame > | readPictureFrame (shared_ptr< HanMacWrdKZone > zone, HanMacWrdKGraphInternal::Frame const &header)
| try to read the picture data More...
shared_ptr< HanMacWrdKGraphInternal::Table > | readTable (shared_ptr< HanMacWrdKZone > zone, HanMacWrdKGraphInternal::Frame const &header)
| try to read the table data More...
shared_ptr< HanMacWrdKGraphInternal::TextBox > | readTextBox (shared_ptr< HanMacWrdKZone > zone, HanMacWrdKGraphInternal::Frame const &header, bool isMemo)
| try to read the textbox data More...

## Protected Attributes
MWAWParserStatePtr | m_parserState
| the parser state More...
shared_ptr< HanMacWrdKGraphInternal::State > | m_state
| the state More...
HanMacWrdKParser * | m_mainParser
| the main parser; More...

## Private Member Functions
| HanMacWrdKGraph (HanMacWrdKGraph const &orig)
HanMacWrdKGraph & | operator= (HanMacWrdKGraph const &orig)

## Friends
class | HanMacWrdKParser
class | HanMacWrdKGraphInternal::SubDocument
struct | HanMacWrdKGraphInternal::Table

## Detailed Description

the main class to read the graphic part of a HanMac Word file

## Constructor & Destructor Documentation

HanMacWrdKGraph::HanMacWrdKGraph | ( | HanMacWrdKParser & | parser | ) |

constructor

HanMacWrdKGraph::~HanMacWrdKGraph | ( |  | ) |
| virtual

destructor

HanMacWrdKGraph::HanMacWrdKGraph | ( | HanMacWrdKGraph const & | orig | ) |
| private

## Member Function Documentation

bool HanMacWrdKGraph::canCreateGraphic | ( | HanMacWrdKGraphInternal::Group const & | group | ) |
| protected

check if we can send a group as graphic

Referenced by sendFrame(), and sendGroupChild().

bool HanMacWrdKGraph::checkGroupStructures | ( | long | fileId,
|  | long | fileSubId,
|  | std::multimap< long, long > & | seens,
|  | bool | inGroup
| ) |  |
| protected

check the graph structures: ie.

the group children

Referenced by prepareStructures().

void HanMacWrdKGraph::flushExtra | ( |  | ) |
| protected

sends the data which have not yet been sent to the listener

bool HanMacWrdKGraph::getColor | ( | int | colId,
|  | int | patternId,
|  | MWAWColor & | color
| ) |  | const
| protected

returns the color associated with a pattern

std::map< long, int > HanMacWrdKGraph::getTextFrameInformations | ( |  | ) | const
| protected

return a list textZId -> type which 3(footnote), 4(textbox), 9(table), 10(comment)

int HanMacWrdKGraph::numPages | ( |  | ) | const

returns the number of pages

HanMacWrdKGraph& HanMacWrdKGraph::operator= | ( | HanMacWrdKGraph const & | orig | ) |
| private

void HanMacWrdKGraph::prepareStructures | ( |  | ) |
| protected

check the group structures, the linked textbox

shared_ptr< HanMacWrdKGraphInternal::FootnoteFrame > HanMacWrdKGraph::readFootnoteFrame | ( | shared_ptr< HanMacWrdKZone > | zone,
|  | HanMacWrdKGraphInternal::Frame const & | header
| ) |  |
| protected

try to read the footnote data

Referenced by readFrames().

bool HanMacWrdKGraph::readFrames | ( | shared_ptr< HanMacWrdKZone > | zone | ) |
| protected

try to read the frame definition (type 2)

shared_ptr< HanMacWrdKGraphInternal::Group > HanMacWrdKGraph::readGroup | ( | shared_ptr< HanMacWrdKZone > | zone,
|  | HanMacWrdKGraphInternal::Frame const & | header
| ) |  |
| protected

try to read the group data

Referenced by readFrames().

bool HanMacWrdKGraph::readPicture | ( | shared_ptr< HanMacWrdKZone > | zone | ) |
| protected

try to read a picture zone (type d)

shared_ptr< HanMacWrdKGraphInternal::PictureFrame > HanMacWrdKGraph::readPictureFrame | ( | shared_ptr< HanMacWrdKZone > | zone,
|  | HanMacWrdKGraphInternal::Frame const & | header
| ) |  |
| protected

try to read the picture data

Referenced by readFrames().

shared_ptr< HanMacWrdKGraphInternal::ShapeGraph > HanMacWrdKGraph::readShapeGraph | ( | shared_ptr< HanMacWrdKZone > | zone,
|  | HanMacWrdKGraphInternal::Frame const & | header
| ) |  |
| protected

try to read the basic graph data

Referenced by readFrames().

shared_ptr< HanMacWrdKGraphInternal::Table > HanMacWrdKGraph::readTable | ( | shared_ptr< HanMacWrdKZone > | zone,
|  | HanMacWrdKGraphInternal::Frame const & | header
| ) |  |
| protected

try to read the table data

Referenced by readFrames().

shared_ptr< HanMacWrdKGraphInternal::TextBox > HanMacWrdKGraph::readTextBox | ( | shared_ptr< HanMacWrdKZone > | zone,
|  | HanMacWrdKGraphInternal::Frame const & | header,
|  | bool | isMemo
| ) |  |
| protected

try to read the textbox data

Referenced by readFrames().

bool HanMacWrdKGraph::sendEmptyPicture | ( | MWAWPosition | pos | ) |
| protected

try to send an empty picture

Referenced by HanMacWrdKGraphInternal::SubDocument::parse().

bool HanMacWrdKGraph::sendFrame | ( | long | frameId,
|  | MWAWPosition | pos
| ) |  |
| protected

try to send a frame to the listener

Referenced by flushExtra(), HanMacWrdKGraphInternal::SubDocument::parse(), sendGroupChild(), and sendPageGraphics().

bool HanMacWrdKGraph::sendFrame | ( | HanMacWrdKGraphInternal::Frame const & | frame,
|  | MWAWPosition | pos
| ) |  |
| protected

try to send a frame to the listener

bool HanMacWrdKGraph::sendGroup | ( | long | fId,
|  | MWAWPosition | pos
| ) |  |
| protected

try to send a group to the listener

Referenced by HanMacWrdKGraphInternal::SubDocument::parse(), sendFrame(), sendGroup(), and sendGroupChild().

bool HanMacWrdKGraph::sendGroup | ( | HanMacWrdKGraphInternal::Group const & | group,
|  | MWAWPosition | pos
| ) |  |
| protected

try to send a group to the listener

void HanMacWrdKGraph::sendGroup | ( | HanMacWrdKGraphInternal::Group const & | group,
|  | MWAWGraphicListenerPtr & | listener
| ) |  |
| protected

send the group as a graphic zone

void HanMacWrdKGraph::sendGroupChild | ( | HanMacWrdKGraphInternal::Group const & | group,
|  | MWAWPosition const & | pos
| ) |  |
| protected

try to send a group elements by elements

Referenced by sendGroup().

bool HanMacWrdKGraph::sendPageGraphics | ( | std::vector< long > const & | doNotSendIds | ) |
| protected

try to send the page graphic

bool HanMacWrdKGraph::sendPicture | ( | long | pictId,
|  | MWAWPosition | pos
| ) |  |
| protected

try to send a picture to the listener

Referenced by flushExtra(), HanMacWrdKGraphInternal::SubDocument::parse(), and sendPictureFrame().

bool HanMacWrdKGraph::sendPicture | ( | HanMacWrdKGraphInternal::Picture const & | picture,
|  | MWAWPosition | pos
| ) |  |
| protected

try to send a picture to the listener

bool HanMacWrdKGraph::sendPictureFrame | ( | HanMacWrdKGraphInternal::PictureFrame const & | pict,
|  | MWAWPosition | pos
| ) |  |
| protected

try to send a picture frame

Referenced by sendFrame().

bool HanMacWrdKGraph::sendShapeGraph | ( | HanMacWrdKGraphInternal::ShapeGraph const & | shape,
|  | MWAWPosition | pos
| ) |  |
| protected

try to send a basic picture to the listener

Referenced by sendFrame().

bool HanMacWrdKGraph::sendTableUnformatted | ( | long | fId | ) |
| protected

try to send a table unformatted

Referenced by HanMacWrdKGraphInternal::SubDocument::parse().

bool HanMacWrdKGraph::sendText | ( | long | textId,
|  | long | id,
|  | MWAWListenerPtr | listener = `MWAWListenerPtr()`
| ) |  |
| protected

ask main parser to send a text zone

Referenced by HanMacWrdKGraphInternal::SubDocument::parse(), and HanMacWrdKGraphInternal::Table::sendText().

bool HanMacWrdKGraph::sendTextBox | ( | HanMacWrdKGraphInternal::TextBox const & | textbox,
|  | MWAWPosition | pos
| ) |  |
| protected

try to send a textbox to the listener

Referenced by sendFrame().

int HanMacWrdKGraph::version | ( |  | ) | const

returns the file version

## Friends And Related Function Documentation

friend class HanMacWrdKGraphInternal::SubDocument
| friend

friend struct HanMacWrdKGraphInternal::Table
| friend

friend class HanMacWrdKParser
| friend

## Member Data Documentation

HanMacWrdKParser* HanMacWrdKGraph::m_mainParser
| protected

the main parser;

Referenced by canCreateGraphic(), sendFrame(), sendGroupChild(), and sendText().

MWAWParserStatePtr HanMacWrdKGraph::m_parserState
| protected

the parser state

Referenced by sendEmptyPicture(), sendFrame(), sendGroup(), sendGroupChild(), sendPicture(), sendPictureFrame(), sendShapeGraph(), sendTableUnformatted(), sendTextBox(), and version().

shared_ptr<HanMacWrdKGraphInternal::State> HanMacWrdKGraph::m_state
| protected

the state

Referenced by canCreateGraphic(), checkGroupStructures(), flushExtra(), getColor(), getTextFrameInformations(), numPages(), prepareStructures(), readFrames(), readPicture(), readTable(), sendFrame(), sendGroup(), sendGroupChild(), sendPageGraphics(), sendPicture(), and sendTableUnformatted().

The documentation for this class was generated from the following files:

- HanMacWrdKGraph.hxx
- HanMacWrdKGraph.cxx